﻿var joe = new Customer { FirstName = "Joe", LastName = "Black" };
var john = new Employee { FirstName = "John", LastName = "Doe", Salary = 1250 };
var jack = new Helper { FirstName = "Jack", Salary = 950 };

IncreaseSalary(john);
Console.WriteLine();

// error CS1503: Argument 1: cannot convert from 'Customer' to 'PersonOnPayroll'
// IncreaseSalary(joe);

void IncreaseSalary(PersonOnPayroll person)
{
    Console.WriteLine($"IncreaseSalary: increasing for {person} ...");
}

abstract record Person
{
    public string? FirstName { get; set; }
    public string? LastName { get; set; }
}

record Customer : Person { }

record PersonOnPayroll : Person
{
    public decimal Salary { get; set; }
}

record Employee : PersonOnPayroll { }
record Helper : PersonOnPayroll { }
